/* rc4.c: rc4 streams functions - create a buffer stream of ....

   Author : KoreK
   Date : Aug 03, 2004
   License : GPL v2 or above (see COPYING file or get it from the FSF)

   Copyright (c) 2004 KoreK, All Rights Reserved
*/

#include <string.h>
#include "rc4.h"

/* first call init_wep_stream 
   then set_key/set_iv
   copy_wep/encode_wep
   destroy_wep_stream at the end */



int init_wep_stream(struct wep_stream *w,size_t Klen,const u_char *K)
{
    if ((Klen+3)>WEPKEY_MAXLEN) {
	return -1;
    }
    memcpy(w->K+3,K,Klen);
    w->klen=Klen+3;
    return 0;
}


void setIV(struct wep_stream *w,const u_char *iv)
{
    size_t i,j;
    u_char sw;

    for (i=0;i<256;i++) w->S[i]=i;
    for (i=0;i<3;i++) w->K[i]=iv[i];
    
    for (i=0,j=0;i<256;i++) {
	j=(j+w->S[i]+w->K[i % w->klen]) & 0xff;
	sw=w->S[i];
	w->S[i]=w->S[j];
	w->S[j]=sw;
    }
    w->i=0;
    w->j=0;
}


void encode_wep(struct wep_stream *w,u_char *buf,size_t len)
{
    size_t i,j;
    u_char t,sw;

    i=w->i;
    j=w->j;

    for (;len>0;len--,buf++) {
	i=(i+1) & 0xff;
	j=(j+w->S[i]) & 0xff;
	t=(w->S[i]+w->S[j]) & 0xff;
	sw=w->S[i];
	w->S[i]=w->S[j];
	w->S[j]=sw;
	*buf^=w->S[t];
    }
    w->i=i;
    w->j=j;
}

void copy_wep(struct wep_stream *w,u_char *buf,size_t len)
{
    size_t i,j;
    u_char t,sw;

    i=w->i;
    j=w->j;

    for (;len>0;len--,buf++) {
	i=(i+1) & 0xff;
	j=(j+w->S[i]) & 0xff;
	t=(w->S[i]+w->S[j]) & 0xff;
	sw=w->S[i];
	w->S[i]=w->S[j];
	w->S[j]=sw;
	*buf=w->S[t];
    }
    w->i=i;
    w->j=j;
}

