/* rc4.h: rc4 functions

   Author : KoreK
   Date : Aug 03, 2004
   License : GPL v2 or above (see COPYING file or get it from the FSF)

  Copyright (c) 2004 KoreK, All Rights Reserved
*/

#ifndef RC4_H
#define RC4_H

#include <sys/types.h>
#define WEPKEY_MAXLEN 32

struct wep_stream {
    u_char S[256];
    u_char K[WEPKEY_MAXLEN];
    size_t klen;
    u_char i;
    u_char j;

};

typedef struct wep_stream wep_stream_t[1];

/* set the key in a struct wep_struct */
int init_wep_stream(struct wep_stream *w,size_t Klen,const u_char *K);

/* init a key with specified 3 byte iv */
void setIV(struct wep_stream *w,const u_char *iv);

/* encode buf with rc4 stream */
void encode_wep(struct wep_stream *w,u_char *buf,size_t len);

/* copy rc4 stream to buf */
void copy_wep(struct wep_stream *w,u_char *buf,size_t len);

#endif
